/*
** iplog_filter.h - iplog filter data.
** Copyright (C) 1999 Odin <odin@numb.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License, version 2,
** as published by the Free Software Foundation.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
*/

#ifndef __FILTER_H
#define __FILTER_H

#define MAX_PORT 0xffff
#define MIN_PORT 0

#define ADDR_MATCH_ALL 0
#define MASK_MATCH_ONE 0xffffffff

#define EVERYTHING "*"

enum { FIL_TCP, FIL_UDP, FIL_ICMP };

struct filter_data {
	struct filter_data *next;
	struct port_range {
		int min;
		int max;
		bool not;
	} sport, dport;
	struct addr_entry {
		u_long addr;
		u_long mask;
		bool not;
	} src, dst;
	bool not;
};

void add_dns_ignore_rules(void);
void read_filters(const u_char *);
bool apply_icmp_filter(const struct filter_data *, const struct ip *, u_char);
bool apply_filter(const struct filter_data *, const struct ip *, u_short, u_short);

#endif
/* vim:ts=4:sw=8:tw=0 */
